function crm00001002_Motivo_Contato_Perfil_Atividade_Controller(General, CRM_Utilities, ScreenService) {
    
    /**
     * Função para salvar um motivo de contato
     * ao perfil de atividade em caso.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do motivo.
    */
    this.saveNewActivityProfileContactReason = function(widget){
        
        var currentRow = widget.currentRow;
        
        var activityProfileContactReasons= currentRow.MOTIVOS;
        var rows = [];
        
        activityProfileContactReasons.forEach(function(reason, reasonIndex){
            
            rows.push(this.setActivityProfileReasonValuesInCurrentRow(widget, reasonIndex));
                
        }.bind(this)); 
        
        General.callRestEngine("product#/crm_perfimoticont_moticont/save", "DataSet", rows).then(function(response){
                
                ScreenService.closeSwipe().then(function(){
                    
                    widget.reload();
                    
                });
                
        }.bind(this));
    };
    
    /**
     * Função para pegar as informações do 
     * array de motivos na currentRow, e
     * tratá-las em uma cópia da currentRow para
     * realizar o save.
     * 
     * @param {object} widget widget ativa onde está
     * sendo realizado o cadastro do motivo do contato.
     * 
     * @param {int} reasonIndex index do motivo
     * no array de motivos presente na currentRow.
    */
    this.setActivityProfileReasonValuesInCurrentRow = function(widget, reasonIndex){
        
        var currentRow = angular.copy(widget.currentRow);
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.__is_new = true;
        currentRow.NRSEQPERFATIV = widget.getParent().currentRow.NRSEQPERFATIV;
        currentRow.CDMOTICONT= currentRow.MOTIVOS[reasonIndex];
        currentRow.NRORG = loggedOperatorInfos.NRORG;
        
        return currentRow;
        
    };
    
    /**
     * Função para inserir um filtro na field
     * de motivos de contato e logo em seguida,
     * atualiza a field.
     * 
     * @param {object} widget widget ativa no
     * modo edit, onde está sendo mostrado o campo
     * de motivos.
    */
    this.insertContactReasonFilter = function(widget){
        
        var reasonField = widget.getField("MOTIVOS");
        var reasonFieldFilter = reasonField.dataSourceFilter;
        
        var nrseqperfativIndex = CRM_Utilities.getFilterPosition(reasonFieldFilter, "P_NRSEQPERFATIV");
        
        reasonFieldFilter[nrseqperfativIndex].value = widget.getParent().currentRow.NRSEQPERFATIV;
        
        reasonField.reload();
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('crm00001002_Motivo_Contato_Perfil_Atividade_Controller', crm00001002_Motivo_Contato_Perfil_Atividade_Controller);
});