function crm00030000_Notificacoes_Controller(ScreenService, Operador_Repository, restEngine, templateManager, Utilities)
{
    var self = this;

    self.iniciaFiltroswdg_notificacoes = function(widget)
    {
        Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            if(operator[0] === undefined || operator[0] === null)
            {
                ScreenService.showMessage("Erro ao realizar a operação.");
                return;
            }
            var cdoperador = operator[0].CDOPERADOR ? operator[0].CDOPERADOR : -1;
            Utilities.insertFilter(widget, "CDOPERNOTIFICADO", "=", cdoperador, 0);
        }, function(error)
        {
            ScreenService.showMessage("Erro ao realizar a operação.");
        });
    };

	this.confirmaAlteracaoNotificacao = function(widget, idconfirma)
	{
		restEngine.post('crm#/trocaValorNotificacao',
        {'requestType':'Row', 'row': {'notificacoes': widget.currentRow, 'idconfirma': idconfirma}},
        	function()
            {
                ScreenService.notificationMessage("Alteração da notificação confirmada com sucesso.", "success");
            }, undefined,
            function(error)
            {
                ScreenService.notificationMessage("Falha ao confirmar alteração da Notificação.", "error");
                console.log(error);
            }
        ).then(function()
        {
            var row = [widget.currentRow];

        	self.deletaNotificacao(row);
            ScreenService.closeSwipe();
        });
	};

	this.deletaNotificacao = function(row)
	{
		restEngine.post('crm#/deletaRelacaoNotificacao',
        {'requestType':'Row', 'row': row},
        	function()
            {
                ScreenService.notificationMessage("Notificação deletada com sucesso.", "success");
            }, undefined,
            function(error)
            {
                ScreenService.notificationMessage("Falha ao deletar Notificação.", "error");
                console.log(error);
            }
        ).then(function()
        {
            templateManager.container.getWidget('wdg_notificacoes').reload();
        });
	};

	this.controlaActionsNotificacao = function(widget)
	{
		var row = widget.currentRow;
		if(((row.DSEVENTONOTIFICACAO == 'SITUACAO') || (row.DSEVENTONOTIFICACAO == 'FASENEGOCIO')) && (row.IDACEITARECUSA === null))
		{
			widget.getAction('aceitar').isVisible = true;
			widget.getAction('recusar').isVisible = true;
		}
        else
        {
            widget.getAction('aceitar').isVisible = false;
            widget.getAction('recusar').isVisible = false;
        }
	};
}


Configuration(function(ContextRegister)
{
    ContextRegister.register('crm00030000_Notificacoes_Controller', crm00030000_Notificacoes_Controller);
});